import { TSESLint } from "@typescript-eslint/utils";
import { Type, Symbol, IndexKind, TypeChecker, Signature } from "typescript";
export type TypePairArray = ReadonlyArray<{
    readonly destinationType: Type;
    readonly sourceType: Type;
}>;
export type SignaturePairArray = ReadonlyArray<{
    readonly destinationSignature: Signature;
    readonly sourceSignature: Signature;
}>;
export type MessageId = "errorStringCallExpression" | "errorStringAssignmentExpression" | "errorStringVariableDeclaration" | "errorStringArrowFunctionExpression" | "errorStringTSAsExpression" | "errorStringTSTypeAssertion";
export type UnsafeIndexAssignmentFunc = (indexKind: IndexKind, destinationType: Type, sourceType: Type, checker: TypeChecker) => boolean;
export type UnsafePropertyAssignmentFunc = (destinationProperty: Symbol, sourceProperty: Symbol | undefined, destinationType: Type, sourceType: Type, checker: TypeChecker) => boolean;
export declare const createNoUnsafeAssignmentRule: (unsafePropertyAssignmentFunc: UnsafePropertyAssignmentFunc, unsafeIndexAssignmentFunc: UnsafeIndexAssignmentFunc) => (context: Readonly<TSESLint.RuleContext<MessageId, readonly unknown[]>>) => TSESLint.RuleListener;
